//---------------------------------------------------------------------
#include "MainWindow.h"
//---------------------------------------------------------------------
BAppMainWindow::BAppMainWindow(BRect frame,const char *title)
	:BWindow(frame,title,MAINWINDOW_WINDOWSTYLE,0)
{
	mainview=new BAppMainView(Bounds());	
	AddChild(mainview);
}
//---------------------------------------------------------------------
void BAppMainWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
		case MSG_COPY:
			mainview->textview->Copy(be_clipboard);
			break;
		case MSG_CUT:
			mainview->textview->Cut(be_clipboard);
			break;
		case MSG_PASTE:
			mainview->textview->Paste(be_clipboard);
			break;
		case MSG_UNDO:
			mainview->textview->Undo(be_clipboard);
			break;
		default:
			BWindow::MessageReceived(msg);
	}
}
//---------------------------------------------------------------------
BAppMainView::BAppMainView(BRect frame)
	:BView(frame,"bappmainview",B_FOLLOW_ALL,B_WILL_DRAW)
{
	BRect viewrect(Bounds());
	BButton *btn;

	BMessage *cpymsg=new BMessage(MSG_COPY);
	BMessage *cutmsg=new BMessage(MSG_CUT);
	BMessage *pstmsg=new BMessage(MSG_PASTE);
	BMessage *udomsg=new BMessage(MSG_UNDO);

	BRect f(8,8,viewrect.right-8-B_V_SCROLL_BAR_WIDTH,
	            viewrect.bottom-40-B_H_SCROLL_BAR_HEIGHT);

	textview=new BTextView(f,"textview",BRect(0,0,f.Width(),f.Height()),B_FOLLOW_ALL,B_WILL_DRAW);
	BScrollView *scr=new BScrollView("memoscroll",textview,
	                                 B_FOLLOW_ALL,0,false,true);
	AddChild(scr);
	textview->SetDoesUndo(true);

	btn=new BButton(BRect(viewrect.right-68,viewrect.bottom-32,
	                      viewrect.right-8,viewrect.bottom-8),
		            "undobtn","UNDO",udomsg);
	AddChild(btn);

	btn=new BButton(BRect(viewrect.right-136,viewrect.bottom-32,
	                      viewrect.right-76,viewrect.bottom-8),
		            "pastebtn","PASTE",pstmsg);
	AddChild(btn);

	btn=new BButton(BRect(viewrect.right-204,viewrect.bottom-32,
	                      viewrect.right-144,viewrect.bottom-8),
		            "cutbtn","CUT",cutmsg);
	AddChild(btn);

	btn=new BButton(BRect(viewrect.right-272,viewrect.bottom-32,
	                      viewrect.right-212,viewrect.bottom-8),
		            "copybtn","COPY",cpymsg);
	AddChild(btn);
}
//---------------------------------------------------------------------
